
int cmd = 0;

int sensor[8];
int sensor_m[8];
int d[8];

const int sensor_w[8] = {50, 50, 50, 50, 50, 50, 50, 50};
const int sensor_b[8] = {800, 800, 800, 800, 800, 800, 800, 800};

const int k1 = 1;
const int k2 = 2;
const int k3 = 3;
const int k4 = 4;
const int mid = 500;
const int spd = 255;

const float k_p = 0.1;
const float k_i = 0.01;
const float k_d = 0.001;
const float dt = 0.001;

const int button = 2;

const int IN_1 = 3;
const int IN_2 = 4;
const int IN_3 = 7;
const int IN_4 = 8;

//const int IN_1 = 7;
//const int IN_2 = 8;
//const int IN_3 = 3;
//const int IN_4 = 4;

const int EN_1 = 5;
const int EN_2 = 9;

void update_liner()
{
  for (int i = 0; i < 8; i++)
  {
    if (sensor[i] > mid) d[i + 1] = 1;
    else d[i + 1] = 0;
  }
}

void vpered()
{
  digitalWrite(IN_1, 1);
  digitalWrite(IN_2, 0);

  digitalWrite(IN_3, 1);
  digitalWrite(IN_4, 0);

  analogWrite(EN_1, spd);
  analogWrite(EN_2, spd);
}

void nalevo()
{
  digitalWrite(IN_1, 0);
  digitalWrite(IN_2, 1);

  digitalWrite(IN_3, 1);
  digitalWrite(IN_4, 0);

  analogWrite(EN_1, spd);
  analogWrite(EN_2, spd);
}

void napravo()
{
  digitalWrite(IN_1, 1);
  digitalWrite(IN_2, 0);

  digitalWrite(IN_3, 0);
  digitalWrite(IN_4, 1);

  analogWrite(EN_1, spd);
  analogWrite(EN_2, spd);
}

void map_sensors()
{
  for (int i = 0; i < 8; i++)
  {
    sensor_m[i] = map(sensor[i], sensor_w[i], sensor_b[i], 0, 1000);
  }
}
void read_sensors()
{
  for (int i = 0; i < 8; i++)
  {
    sensor[i] = analogRead(14 + i);
  }
}

int summ()
{
  int s = k1 * (sensor_m[3] - sensor_m[4]) +
          k2 * (sensor_m[2] - sensor_m[5]) +
          k3 * (sensor_m[1] - sensor_m[6]) +
          k4 * (sensor_m[0] - sensor_m[7]);
  return s;
}

void logic()
{
  
  
  if ((d[8] == 0) &&
      ((d[6] == 1) || (d[5] == 1) || (d[4] == 1) || (d[3] == 1))
      && (d[1] == 0)) vpered();
  else if (d[8] == 1) nalevo();
  else if  (d[1] == 1) napravo();
}

int PID()
{
  static float integral = 0;
  static float prev_error = 0;
  float D = (summ() - prev_error) / dt;
  integral = integral + (float)summ() * dt * k_i;
  return constrain(summ() * k_p + integral + D * k_d, -510, 510);
}

void print_d()
{
  for (int i = 1; i <= 8; i++)
  {
    Serial.print(d[i]);
    Serial.print("\t");
  }
  Serial.println();
}

void print_sensors()
{
  for (int i = 0; i < 8; i++)
  {
    Serial.print(sensor[i]);
    Serial.print("\t");
  }
  Serial.println();
}

void setup() {
  Serial.begin(115200);
  pinMode(A0, INPUT);
  pinMode(A1, INPUT);
  pinMode(A2, INPUT);
  pinMode(A3, INPUT);
  pinMode(A4, INPUT);
  pinMode(A5, INPUT);
  pinMode(A6, INPUT);
  pinMode(A7, INPUT);
  pinMode(button, INPUT_PULLUP);
  pinMode(IN_1, OUTPUT);
  pinMode(IN_2, OUTPUT);
  pinMode(IN_3, OUTPUT);
  pinMode(IN_4, OUTPUT);
  pinMode(EN_1, OUTPUT);
  pinMode(EN_2, OUTPUT);

  while (digitalRead(button) == 1)
  {
    delay(1);
  }
}

void loop() {
  // put your main code here, to run repeatedly:
  read_sensors();
  //print_sensors();
  //map_sensors();
  update_liner();
  logic();
  //print_d();
  //Serial.println(PID());
  delay(1);

  if (Serial.available())
  {
    cmd = Serial.parseInt();
  }

  switch (cmd)
  {
    case 1: vpered();
      Serial.println("Vpered");
      break;
    case 2: nalevo();
      Serial.println("Nalevo");
      break;
    case 3: napravo();
      Serial.println("Napravo");
      break;
    case 4: print_sensors();
      Serial.println("print sensors");
      break;
  }
}
